VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Sample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Project: Messenger Plus! simple plugin in Visual Basic 6         //
'// Author: Patchou                                                  //
'// Last Update: 2005/08/15                                          //
'//                                                                  //
'// For more help, please read the documentation in MPPluginDef.cls  //
'// and in MPPluginConst.bas                                         //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Option Explicit


'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Initialization function                                 //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function Initialize(ByVal nVersion As Long, ByVal sUserEmail As String, ByVal oMessenger As Object) As Boolean
    Initialize = True
    
    ShowWindow Form1.hwnd, SW_SHOWNOACTIVATE
End Function


'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Uninitialization function                               //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function Uninitialize()
End Function


'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Configuration/Information function                      //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function Configure()
    MsgBox "Sample plugin made in Visual Basic 6" + vbLf + "Author: Patchou", vbOKOnly, "About Sample in VB..."
End Function


'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Inform the users about the features of the plugin       //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function GetPublishInfo(ByRef sPluginName As String, ByRef nCommandCount As Long, ByRef nTagCount As Long) As Boolean
    sPluginName = "Sample in VB6" 'This name will be displayed in the Plus!\Plugins menu
    nCommandCount = 6
    nTagCount = 1
    
    GetPublishInfo = True
End Function

Public Function GetPublishCommandInfo(ByVal nCommandIdx As Long, ByRef sName As String, ByRef sValue As String, ByRef sHelp As String)
    If (nCommandIdx = 1) Then
        sName = "Displays the Parameter"
        sValue = "xsamplevb"
        sHelp = "any text"
    ElseIf (nCommandIdx = 2) Then
        sName = "Ping"
        sValue = "xpingvb"
    ElseIf (nCommandIdx = 3) Then
        sName = "Bybye"
        sValue = "xbyevb"
    ElseIf (nCommandIdx = 4) Then
        sName = "Displays a Toast"
        sValue = "xtoastvb"
    ElseIf (nCommandIdx = 5) Then
        sName = "Changes Display Name"
        sValue = "xnamevb"
        sHelp = "new name"
    ElseIf (nCommandIdx = 6) Then
        sName = "Add Event Log Entry"
        sValue = "xeventvb"
        sHelp = "event description"
    End If
End Function

Public Function GetPublishTagInfo(ByVal nTagIdx As Long, ByRef sName As String, ByRef sValue As String)
    If (nTagIdx = 1) Then
        sName = "Random Quote"
        sValue = "(!XSAMPVB)"
    End If
End Function


'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Provide new commands in Messenger Plus!                 //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function ParseCommand(ByVal sCommand As String, ByVal sCommandArg As String, ByVal oConversationWnd As Object, ByRef sResult As String) As Boolean
    'The first sample command displays a hello box and cancels the message
    If (StrComp(LCase(sCommand), "/xsamplevb", vbTextCompare) = 0) Then
        'Display a message including the given parameter
        Dim sMessage As String
        sMessage = "The parameter is: " + sCommandArg
        MsgBox (sMessage)
        
        'Send back an empty string to cancel the message
        sResult = ""
        ParseCommand = True
        Exit Function
        
    'The second sample command simulates a !ping request. See
    'ReceiveNotify() for more information. You could improve it by ignoring
    'the next ReceiveNotify() call to avoid a local answer (obviously, you
    'can ping yourself).
    ElseIf (StrComp(LCase(sCommand), "/xpingvb", vbTextCompare) = 0) Then
        sResult = Chr(nCCNotify) + "smvpg" 'The notify code must be 5 characters long
        sResult = sResult + "Ping?"
        
        ParseCommand = True
        Exit Function
    
    'This third sample illustrates how to use the multiple action feature
    'available if nVersion sent in Initialize() is 2 or above
    ElseIf (StrComp(LCase(sCommand), "/xbyevb", vbTextCompare) = 0) Then
        sResult = "#I'm leaving, see ya!" + vbLf
        sResult = sResult + "#/away"
        
        ParseCommand = True
        Exit Function
        
    'This fourth sample shows how to display toast popup notifications if
    'nVersion sent in Initialize() is 3 or above
    ElseIf (StrComp(LCase(sCommand), "/xtoastvb", vbTextCompare) = 0) Then
        Dim bToastResult As Boolean
        bToastResult = DisplayToast("Be happy!", "Toast Plugin Sample", "http://www.msgplus.net", True)

        sResult = ""
        ParseCommand = True
        Exit Function
        
    'This fifth sample shows how to change the name of the current user if
    'nVersion sent in Initialize() is 5 or above
    ElseIf (StrComp(LCase(sCommand), "/xnamevb", vbTextCompare) = 0) Then
        Dim bNameResult As Boolean
        bNameResult = SetNewName(sCommandArg)

        sResult = ""
        ParseCommand = True
        Exit Function

    'This sixth sample shows how to add custom events in the event log
    ElseIf (StrComp(LCase(sCommand), "/xeventvb", vbTextCompare) = 0) Then
        Dim bAddEventResult As Boolean
        bAddEventResult = AddEventEntry("(plugin demo)", sCommandArg)

        sResult = ""
        ParseCommand = True
        Exit Function
    End If
    
    'Give other plugins a chance to parse this command
    ParseCommand = False
End Function


'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Provide new tags in Messenger Plus!                     //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function ParseTag(ByVal sTag As String, ByVal oConversationWnd As Object, ByRef sResult As String) As Boolean
    'This sample returns a random quote for the tag
    If (StrComp(sTag, "(!XSAMPVB)", vbTextCompare) = 0) Then
        Randomize
        Dim nRandom As Long
        nRandom = Int(Rnd * 3)
        If (nRandom = 0) Then
            sResult = "[quote 1]"
        ElseIf (nRandom = 1) Then
            sResult = "[quote 2]"
        Else
            sResult = "[quote 3]"
        End If

        ParseTag = True
        Exit Function
    End If
    
    'Give other plugins a chance to parse this tag
    ParseTag = False
End Function


'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Allow special actions when a plugin text is received    //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function ReceiveNotify(ByVal sNotifyCode As String, ByVal sText As String, ByVal sContactName As String, ByVal oConversationWnd As Object, ByRef sTextToSend As String) As Boolean
    'This sample responds to a !ping request sent by /xpingvb
    If (StrComp(sNotifyCode, "smvpg", vbTextCompare) = 0) Then
        sTextToSend = "Pong!"
        
        'You can add more actions if the plugin engine version is 2
        'or above
        sTextToSend = sTextToSend + vbLf + "#/brb I'll be back in 5 seconds"
        sTextToSend = sTextToSend + vbLf + "#5#/online"
        
        ReceiveNotify = True
        Exit Function
    End If
    
    'Give other plugins a chance to receive this notification
    ReceiveNotify = False
End Function
